View Issue Details

IDProjectCategoryView StatusLast Update
0003845GNUnetcadet servicepublic2018-06-07 00:25
ReporteramatusAssigned ToBart Polot 
PrioritynormalSeveritycrashReproducibilityalways
Status closedResolutionfixed 
Platformx86OSDebian OS Versionjessie
Product VersionSVN HEAD 
Target Version0.11.0pre66Fixed in Version0.11.0pre66 
Summary0003845: Assertion failure (c->next_peer == peer) in unregister_neighbors (rev 35954)
DescriptionProgram terminated with signal SIGABRT, Aborted.
#0 0x04161ddc in __GI_raise (sig=sig@entry=6)
    at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
56 ../nptl/sysdeps/unix/sysv/linux/raise.c: No such file or directory.
(gdb) bt
#0 0x04161ddc in __GI_raise (sig=sig@entry=6)
    at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
#1 0x04163463 in __GI_abort () at abort.c:89
#2 0x0405d98a in GNUNET_abort_ () at common_logging.c:290
#3 0x08057290 in unregister_neighbors (c=0x5869e40)
    at gnunet-service-cadet_connection.c:1578
#4 0x0805a230 in GCC_destroy (c=0x5869e40)
    at gnunet-service-cadet_connection.c:2804
#5 0x0805a0a0 in GCC_new (cid=0xbedea4ac, t=0x56278f8, path=0x5181638,
    own_pos=0) at gnunet-service-cadet_connection.c:2766
#6 0x080538af in GCT_use_path (t=0x56278f8, p=0x5181638)
    at gnunet-service-cadet_tunnel.c:3750
#7 0x080670f5 in GCP_connect (peer=0x5175d00)
    at gnunet-service-cadet_peer.c:1851
#8 0x0805ece6 in GCCH_handle_local_create (c=0x4a99dd0, msg=0xbedea790)
    at gnunet-service-cadet_channel.c:1871
#9 0x08060e7f in handle_channel_create (cls=0x0, client=0x4a99cb8,
    message=0xbedea790) at gnunet-service-cadet_local.c:394
#10 0x04096993 in GNUNET_SERVER_inject (server=0x4527ca0, sender=0x4a99cb8,
    message=0xbedea790) at server.c:997
#11 0x0409701b in client_message_tokenizer_callback (cls=0x4527ca0,
    client=0x4a99cb8, message=0xbedea790) at server.c:1256
#12 0x04098fca in GNUNET_SERVER_mst_receive (mst=0x4a99d50,
    client_identity=0x4a99cb8, buf=0xbedea790 "", size=48, purge=0,
    one_shot=-1) at server_mst.c:262
#13 0x04096dca in process_incoming (cls=0x4a99cb8, buf=0xbedea790,
    available=48, addr=0x4a99ba8, addrlen=2, errCode=0) at server.c:1178
#14 0x04065788 in receive_ready (cls=0x4a99be0, tc=0xbedfa814)
    at connection.c:1139
#15 0x040928b4 in run_ready (rs=0x4527358, ws=0x4527410) at scheduler.c:587
#16 0x04093142 in GNUNET_SCHEDULER_run (task=0x409dcd0 <service_task>,
    task_cls=0xbedfaa40) at scheduler.c:867
#17 0x0409f86e in GNUNET_SERVICE_run (argc=7, argv=0xbedfac34,
    service_name=0x806d314 "cadet", options=GNUNET_SERVICE_OPTION_NONE,
    task=0x8069be5 <run>, task_cls=0x0) at service.c:1503
#18 0x08069e77 in main (argc=7, argv=0xbedfac34) at gnunet-service-cadet.c:174
(gdb) f 3
#3 0x08057290 in unregister_neighbors (c=0x5869e40)
    at gnunet-service-cadet_connection.c:1578
1578 gnunet-service-cadet_connection.c: No such file or directory.
(gdb) p *c
$1 = {t = 0x0, fwd_fc = {c = 0x5869e40, queue_n = 0, queue_max = 11,
    last_pid_sent = 4294967295, last_pid_recv = 4294967295, recv_bitmap = 0,
    last_ack_sent = 0, last_ack_recv = 0, poll_task = 0x0, poll_time = {
      rel_value_us = 1000000}, poll_msg = 0x0, ack_msg = 0x0}, bck_fc = {
    c = 0x5869e40, queue_n = 0, queue_max = 11, last_pid_sent = 4294967295,
    last_pid_recv = 4294967295, recv_bitmap = 0, last_ack_sent = 0,
    last_ack_recv = 0, poll_task = 0x0, poll_time = {rel_value_us = 1000000},
    poll_msg = 0x0, ack_msg = 0x0}, perf = 0x0, id = {
    bits = "\023\260{x\\\226\341\323D\203\244\343\262\243N\210\376\302\063\320\335\275v>E\202FE \221#\351"}, path = 0x0, fwd_maintenance_task = 0x0,
  bck_maintenance_task = 0x0, maintenance_q = 0x0, next_peer = 0x5178e28,
  prev_peer = 0x4a99750, state = CADET_CONNECTION_NEW, own_pos = 0,
  pending_messages = 0, destroy = 2, create_retry = 0}
(gdb) p *peer
Cannot access memory at address 0x0


gnunet-service-cadet was run under valgrind and no memory badness was reported when hitting this assertion.
TagsNo tags attached.

Relationships

related to 0003846 closedChristian Grothoff Assertion failed (GNUNET_CONTAINER_multihashmap_remove) in GCP_remove_connection (rev 35954) 

Activities

amatus

2015-06-24 19:04

developer   ~0009329

SVN rev 35978 still hits this assertion

Bart Polot

2015-06-24 19:05

manager   ~0009330

Well, damn. I'll keep looking.

Bart Polot

2015-06-25 05:21

manager   ~0009338

I believe r35985 should have fixed this.

Bart Polot

2015-06-26 19:12

manager   ~0009350

Still happens, much more rarely now, and in a different path:

[New LWP 6039]
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib/i386-linux-gnu/i686/cmov/libthread_db.so.1".
Core was generated by `/tmp/gnunet/lib//gnunet/libexec/gnunet-service-cadet -c /home/bart/.config/gnun'.
Program terminated with signal SIGABRT, Aborted.
#0 0xb7750d40 in __kernel_vsyscall ()
(gdb) bt
#0 0xb7750d40 in __kernel_vsyscall ()
#1 0xb74b7307 in __GI_raise (sig=sig@entry=6) at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
#2 0xb74b89c3 in __GI_abort () at abort.c:89
#3 0xb76c8ef3 in GNUNET_abort_ () at common_logging.c:290
#4 0x08074245 in GCP_remove_connection (peer=0x9a85810, c=0x9a996e8) at gnunet-service-cadet_peer.c:2219
#5 0x0805b7f1 in unregister_neighbors (c=0x9a996e8) at gnunet-service-cadet_connection.c:1586
#6 0x0805fdf0 in GCC_destroy (c=0x9a996e8) at gnunet-service-cadet_connection.c:2823
#7 0x08058a64 in conn_message_sent (cls=0x9a98778, c=0x9a996e8, sent=1, type=258, pid=0, fwd=0, size=100, wait=...)
    at gnunet-service-cadet_connection.c:643
#8 0x080710fa in GCP_queue_destroy (queue=0x9a9aac8, clear_cls=0, sent=1, pid=0) at gnunet-service-cadet_peer.c:1351
#9 0x0807090b in queue_send (cls=0x9a85bb0, size=428, buf=0x9a98c40) at gnunet-service-cadet_peer.c:1240
#10 0xb769b4f8 in transmit_message (cls=0x9a80b40, size=484, buf=0x9a98c08) at core_api.c:676
#11 0xb76c5574 in client_notify (cls=0x9a99d00, size=484, buf=0x9a98c08) at client.c:1201
#12 0xb76d2447 in process_notify (connection=0x9a80c50) at connection.c:1261
#13 0xb76d2e4e in transmit_ready (cls=0x9a80c50, tc=0xbfc8bb54) at connection.c:1405
#14 0xb770063f in run_ready (rs=0x9a8e368, ws=0x9a8e3f0) at scheduler.c:587
#15 0xb7700f42 in GNUNET_SCHEDULER_run (task=0xb770cf2b <service_task>, task_cls=0xbfc8bd80) at scheduler.c:867
#16 0xb770ebcb in GNUNET_SERVICE_run (argc=3, argv=0xbfc8bf74, service_name=0x807d0ba "cadet",
    options=GNUNET_SERVICE_OPTION_NONE, task=0x8076c91 <run>, task_cls=0x0) at service.c:1503
#17 0x08076fe3 in main (argc=3, argv=0xbfc8bf74) at gnunet-service-cadet.c:174

amatus

2015-06-28 01:41

developer   ~0009358

I think this one might be fixed too.

Bart Polot

2015-06-29 14:56

manager   ~0009367

Actually, this one is fixed, 0003846 is the one that still happens.

Issue History

Date Modified Username Field Change
2015-06-19 16:26 amatus New Issue
2015-06-19 16:26 amatus Status new => assigned
2015-06-19 16:26 amatus Assigned To => Bart Polot
2015-06-19 16:27 Bart Polot Relationship added related to 0003794
2015-06-19 16:52 amatus Platform amd64 => x86
2015-06-24 16:52 Bart Polot Status assigned => feedback
2015-06-24 19:04 amatus Note Added: 0009329
2015-06-24 19:04 amatus Status feedback => assigned
2015-06-24 19:05 Bart Polot Note Added: 0009330
2015-06-25 05:19 Bart Polot Relationship added related to 0003846
2015-06-25 05:19 Bart Polot Relationship deleted related to 0003794
2015-06-25 05:21 Bart Polot Note Added: 0009338
2015-06-25 05:21 Bart Polot Status assigned => feedback
2015-06-26 13:37 Christian Grothoff Target Version => 0.11.0pre66
2015-06-26 19:12 Bart Polot Note Added: 0009350
2015-06-26 19:12 Bart Polot Status feedback => acknowledged
2015-06-28 01:41 amatus Note Added: 0009358
2015-06-29 14:56 Bart Polot Note Added: 0009367
2015-06-29 14:56 Bart Polot Status acknowledged => resolved
2015-06-29 14:56 Bart Polot Fixed in Version => SVN HEAD
2015-06-29 14:56 Bart Polot Resolution open => fixed
2015-08-03 15:18 Christian Grothoff Fixed in Version SVN HEAD => 0.11.0pre66
2018-06-07 00:25 Christian Grothoff Status resolved => closed